﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: false
#End Region
'Service module
Sub Process_Globals
    Type Message (Address As String, Body As String)
End Sub
Sub Service_Create
	Dim SI As SmsInterceptor
	SI.Initialize2("SI", 999)
	Log("#0 went into Service Create")
End Sub

Sub Service_Start(startingIntent As Intent)
Log("#1 Service Start")
   If startingIntent.Action = "android.provider.Telephony.SMS_RECEIVED" Then
   		Log("#2 went into startingIntent.Action")
      	Dim messages() As Message
      	messages = ParseSmsIntent(startingIntent)
      	For i = 0 To messages.Length - 1
         	Log(messages(i))
      	Next
   End If
End Sub


'Parses an SMS intent and returns an array of messages
Sub ParseSmsIntent (In As Intent) As Message()
Log("#3 went into parseSMSIntent.Action")
   Dim messages() As Message
   If In.HasExtra("pdus") = False Then Return messages
   Dim pdus() As Object
   Dim r As Reflector
   pdus = In.GetExtra("pdus")
   If pdus.Length > 0 Then
   	Log("#4")
      Dim messages(pdus.Length) As Message
	  Dim From As String
	  Dim smsin As String
      For i = 0 To pdus.Length - 1
         r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", _
            Array As Object(pdus(i)), Array As String("[B"))
         	messages(i).Body = r.RunMethod("getMessageBody")
         	messages(i).Address = r.RunMethod("getOriginatingAddress")
			smsin = r.RunMethod("getMessageBody")
			From = r.RunMethod("getOriginatingAddress")
			Log("Message Body is:   "&smsin)
			Log("Calling Number is: "&From)
		 	If smsin.ToLowerCase = "secret" Then
				Log("going now to SI_MessageReceived")
				SI_MessageReceived(From,smsin)
			End If
      Next
   End If

   Return messages
End Sub

Sub SI_MessageReceived (From As String, Body As String) As Boolean   
	Dim smsOut As PhoneSms
	Log("#6 into si_messageReceived")
	If Body.ToLowerCase = "secret" Then '' this is the lowercase text to look for
		Log("#7 Detected the trigger word to send reply")
		smsOut.Send(From,"message sent from SI_MessageReceived")  '' this is the message to respond with
		Log("auto-reply sent")
		Return True
	Else
		Log("#8")
		Return False
	End If
End Sub

